Util.pm: avoid undefined warnings on various valid_xxx tests
[girocco.git] / shlib.sh
blobc5243bf8062b4a09feb5aa4a2849d8f3e8f45ac8
1 #!/bin/sh
3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
6 get_girocco_config_var_list() {
7 # Export all the variables from Girocco::Config to suitable var= lines
8 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
9 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
10 __girocco_conf="$GIROCCO_CONF"
11 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
12 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
13 perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf -le \
14 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
15 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
16 $val =~ s/([\\"\$\`])/\\$1/gos;
17 $val =~ s/(?:\r\n|\r|\n)$//os;
18 print "cfg_$_=\"$val\"";
19 print "defined_cfg_$_=",
20 (defined(${$Girocco::Config::{$_}})?"1":"");
24 # If basedir has been replaced, and shlib_vars.sh exists, get the config
25 # definitions from it rather than running Perl.
26 if [ "@basedir@" = '@'basedir'@' ] || ! [ -r "@basedir@/shlib_vars.sh" ]; then
27 # Import all the variables from Girocco::Config to the local environment,
28 eval "$(get_girocco_config_var_list)"
29 else
30 # Import the variables from shlib_vars.sh which avoids needlessly
31 # running another copy of Perl
32 . "@basedir@/shlib_vars.sh"
35 git() (
36 # some poorly behaving /bin/sh implementations do not
37 # properly export variables when the command is actually
38 # a shell function -- they are set for the function call
39 # but not exported into the environment for anything the
40 # function executes. Export the two Git variables we
41 # care about if they are set. Since this is a subshell
42 # the export will be temporary.
43 [ -z "$GIT_DIR" ] || export GIT_DIR
44 [ -z "$GIT_SSL_NO_VERIFY" ] || export GIT_SSL_NO_VERIFY
45 exec "$cfg_git_bin" "$@"
48 nc_openbsd() { "$cfg_nc_openbsd_bin" "$@"; }
50 _addrlist() {
51 _list=
52 for _addr in "$@"; do
53 [ -z "$_list" ] || _list="$_list, "
54 _list="$_list$_addr"
55 done
56 echo "$_list"
59 _sendmail() {
60 _mailer="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
61 if [ -n "$cfg_sender" ]; then
62 "$_mailer" -i -f "$cfg_sender" "$@"
63 else
64 "$_mailer" -i "$@"
68 mail() {
69 _subject=
70 if [ "$1" = "-s" ]; then
71 shift
72 _subject="$1"
73 shift
76 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
77 echo "To: $(_addrlist "$@")"
78 [ -z "$_subject" ] || echo "Subject: $_subject"
79 echo "MIME-Version: 1.0"
80 echo "Content-Type: text/plain; charset=utf-8"
81 echo "Content-Transfer-Encoding: 8bit"
82 echo "Auto-Submitted: auto-generated"
83 echo ""
84 cat
85 } | _sendmail "$@"
88 # bang CMD... will execute the command with well-defined failure mode;
89 # set bang_action to string of the failed action ('clone', 'update', ...);
90 # pre-set bang_once=1 to make sure jobs banging on a repo repeatedly will
91 # not spam the owner; re-define the bang_trap() function to do custom
92 # cleanup before bailing out
93 bang() {
94 if [ -n "$show_progress" ]; then
95 exec 3>&1
96 errcode=
97 read -r errcode <<-EOT || :
99 exec 4>&3 3>&1 1>&4 4>&-
100 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -a "$bang_log"
103 exec 3>&-
104 if [ -z "$errcode" ]; then
105 # All right. Cool.
106 return;
108 else
109 if "$@" >>"$bang_log" 2>&1; then
110 # All right. Cool.
111 return;
112 else
113 errcode="$?"
116 if ! [ -e .banged ]; then
117 bangmailok=true
118 ! [ -f HEAD -a -f config -a -d objects ] ||
119 bangmailok="$(GIT_DIR=. git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
120 bangaddrs=''
121 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs="$mail"
122 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
123 if [ -z "$bangaddrs" ]; then bangaddrs="$cfg_admin"; else bangaddrs="$bangaddrs,$cfg_admin"; fi
124 [ -z "$bangaddrs" ] ||
126 echo "$* failed with error code $errcode"
127 echo ""
128 [ ! -n "$bang_once" ] || echo "you will not receive any more notifications until recovery"
129 echo "this status message may be disabled on the project admin page"
130 echo ""
131 echo "Log follows:"
132 echo ""
133 cat "$bang_log"
134 } | mail -s "[$cfg_name] $proj $bang_action failed" "$bangaddrs"
136 touch .banged
137 bang_trap
138 exit 1
141 # bang_eval CMD... will evaluate the command with well-defined failure mode;
142 # Identical to bang CMD... except the command is eval'd instead of executed.
143 bang_eval() {
144 bang eval "$*"
147 # Default bang settings:
148 bang_setup() {
149 bang_action="lame_programmer"
150 bang_once=
151 bang_trap() { :; }
152 bang_log="$(mktemp -t repomgr-XXXXXX)"
153 trap "rm \"\$bang_log\"" EXIT
157 # Progress report - if show_progress is set, shows the given message.
158 progress() {
159 [ ! -n "$show_progress" ] || echo "$@"
163 # Project config accessors; must be run in project directory
164 config_get() {
165 git config "gitweb.$1"
168 config_set() {
169 git config "gitweb.$1" "$2" && chgrp repo config && chmod g+w config
172 config_set_raw() {
173 git config "$1" "$2" && chgrp repo config && chmod g+w config
176 config_get_date_seconds() {
177 _dt="$(config_get "$1" || :)"
178 [ -n "$_dt" ] || return 1
179 _ds="$(perl -I@basedir@ -MGirocco::Util -e "print parse_rfc2822_date('$_dt')")"
180 [ -n "$_ds" ] || return 1
181 echo "$_ds"
184 # Tool for checking whether given number of seconds has not passed yet
185 check_interval() {
186 os="$(config_get_date_seconds "$1")" || return 1
187 ns="$(date +%s)"
188 [ $ns -lt $(($os+$2)) ]
192 # List all Git repositories, with given prefix if specified, one-per-line
193 get_repo_list() {
194 if [ -n "$1" ]; then
195 cut -d : -f 1,3 "$cfg_chroot"/etc/group | grep "^$1"
196 else
197 cut -d : -f 1,3 "$cfg_chroot"/etc/group
198 fi | while IFS=: read name id; do
199 [ $id -lt 65536 ] || echo "$name"
200 done
203 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
204 is_gfi_mirror() {
205 _gitdir="${1-.}"
206 # always return false for non-mirrors
207 [ ! -e "$_gitdir/.nofetch" ] || return 1
208 _url="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
209 case "$_url" in
210 svn://* | svn+http://* | svn+https://*)
211 # Don't think git-svn currently uses git fast-import
212 return 1
214 darcs://*)
215 # darcs mirrors use git fast-import
216 return 0
218 bzr://*)
219 # bzr mirrors use git fast-import
220 return 0
222 hg+http://* | hg+https://*)
223 # hg mirrors use git fast-import
224 return 0
226 esac
227 # assume it does not use git fast-import
228 return 1
231 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
232 git_hg_fetch() {
233 _python="${PYTHON:-python}"
234 _err1=
235 _err2=
236 exec 3>&1
237 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
239 exec 4>&3 3>&1 1>&4 4>&-
241 _e1=0
242 [ -f hg2git-marks ] || touch hg2git-marks
243 _af="$(git config hg.authorsfile || :)"
244 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
245 --repo "$(pwd)/repo.hg" \
246 --marks "$(pwd)/hg2git-marks" \
247 --mapping "$(pwd)/hg2git-mapping" \
248 --heads "$(pwd)/hg2git-heads" \
249 --status "$(pwd)/hg2git-state" \
250 -U unknown --force --flatten'
251 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
252 eval "$_cmd" 3>&- || _e1=$?
253 echo $_e1 >&3
254 } | \
256 _e2=0
257 rm -f hg2git-marks.new
258 git fast-import \
259 --export-marks="$(pwd)/hg2git-marks.new" \
260 --export-pack-edges="$(pwd)/gfi-packs" \
261 --force 3>&- || _e2=$?
262 echo $_e2 >&3
266 exec 3>&-
267 [ "$_err1" = 0 -a "$_err2" = 0 ] || return 1
268 if [ -f hg2git-marks ]; then
269 rm -f hg2git-marks.old
270 mv hg2git-marks hg2git-marks.old
271 else
272 touch hg2git-marks.old
274 cat hg2git-marks.old hg2git-marks.new | LC_ALL=C uniq > hg2git-marks
275 rm hg2git-marks.old hg2git-marks.new
276 rm -f hg2git-heads
277 git branch --no-color | \
278 while IFS= read -r _head; do
279 echo ":${_head#??} $(git rev-parse "refs/heads/${_head#??}")"
280 done > hg2git-heads